4 # Copyright (C) 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21 echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
24 . "$UTIL_VSERVER_VARS"
26 . "$_LIB_VSERVER_BUILD_FUNCTIONS_PKGMGMT"
27 . "$PKGLIBDIR/vserver.functions"
32 $"Usage: $0 --externalize|--internalize [-y] [--] <vserver-name>
34 Report bugs to <$PACKAGE_BUGREPORT>."
38 function showVersion()
41 vpkg $PACKAGE_VERSION -- shows information about packages in vservers
42 This program is part of $PACKAGE_STRING
44 Copyright (C) 2004 Enrico Scholz
45 This program is free software; you may redistribute it under the terms of
46 the GNU General Public License. This program has absolutely no warranty."
52 if test -z "$WORKAROUND_106057"; then
55 rpmdb_mntpoint=/.rpmdb
60 function _createDirs()
68 function _copySecure()
75 ( cd "$srcdir" && tar chf - '.' ) | \
76 ( cd "$chroot" && $_EXEC_CD "$dstdir" $_TAR xf - )
79 function _copySecureRev()
85 ( cd "$chroot" && $_EXEC_CD "$srcdir" $_TAR cf - '.' ) | \
86 ( cd "$dstdir" && tar xf - )
92 local dir=$(dirname "$1")
93 local file=$(basename "$1")
95 $_EXEC_CD "$dir" "$(which test)" "$file" || return 0
97 local tmp=$(mktemp /tmp/apt.conf.XXXXXX)
98 trap "rm -f $tmp" EXIT
100 $_EXEC_CD "$dir" /bin/cat "$file" | \
101 sed -e "s|^\([^$hash].*@autogenerated@\)|$hash$hash\1|" >$tmp
103 cat $tmp | $_EXEC_CD "$dir" "$(which cmp)" -s - "$file" || \
104 $_CHROOT_CAT "$1" <$tmp
109 function _unhashAuto()
111 test -e "$1" || return 0
114 local tmp=$(mktemp /tmp/apt.conf.XXXXXX)
115 trap "rm -f $tmp" EXIT
117 sed -e "s|^$hash$hash\(.*@autogenerated@\)|\1|" "$1" >$tmp
118 cmp -s "$tmp" "$1" || \
124 function _mountFilesystemsInternal()
127 test -e "$fstab" || return 0
130 pushd "$vdir" >/dev/null
131 "$@" $_SECURE_MOUNT -n -a --chroot --fstab "$fstab"
135 function _mountFilesystems()
137 local cfgdir=$($_VSERVER_INFO "$1" CFGDIR) || {
138 echo "Can not determine configuration directory for '$1'; ..." >&2
141 test "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$1"
143 _mountFilesystemsInternal "$cfgdir"/fstab $_CHBIND "${CHBIND_OPTS[@]}" || return 1
144 _mountFilesystemsInternal "$cfgdir"/fstab.local $_CHBIND "${CHBIND_OPTS[@]}" || return 1
147 function _umountFilesystems()
149 local cfgdir=$($_VSERVER_INFO "$1" CFGDIR) || {
150 echo "Can not determine configuration directory for '$1'; ..." >&2
153 local vdir=$cfgdir/vdir
155 test "$_HAVE_CHBIND_OPTIONS" || _generateChbindOptions "$1"
157 pushd "$vdir/" >/dev/null || return 1
158 _umountVserverInternal "$cfgdir"/fstab.local || is_ok=
159 _umountVserverInternal "$cfgdir"/fstab $_CHBIND "${CHBIND_OPTS[@]}" || is_ok=
160 popd >/dev/null || return 1
165 function processVserver_RH()
168 local is_internalize=$2
173 cfgdir=$($_VSERVER_INFO "$vserver" APPDIR pkgmgmt) || \
174 cfgdir=$($_VSERVER_INFO "$vserver" APPDIR)/pkgmgmt
176 ## Figure out the environment....
178 pkgmgmt.isAptAvailable "$cfgdir" "$vdir" "$is_internalize" || have_apt=
187 ## Create directories and assign variables where configuration
188 ## can/will be found on the host
189 if test "$is_internalize"; then
190 pushd "$vdir" >/dev/null
192 test ! -L var/lib/rpm || {
193 $_EXEC_CD /var/lib /bin/rm rpm &&
194 $_EXEC_CD /var/lib /bin/mkdir -m755 rpm &&
195 $_EXEC_CD /var/lib /bin/chown rpm:rpm rpm ||
197 } </dev/null 2>/dev/null
199 for i in var/cache/apt/{,archives/{,partial},genpkglist,gensrclist} \
200 var/state/{,apt/{,lists/{,partial}}} \
203 $_EXEC_CD /$(dirname "$i") /bin/mkdir -m755 $(basename "$i") || :
208 if test "$have_apt"; then
209 findDir APTETCDIR "$cfgdir"/aptetc "$cfgdir"/base/apt/etc /etc/apt /
212 findDir RPMETCDIR "$cfgdir"/rpmetc "$cfgdir"/base/rpm/etc /etc/rpm /
213 findDir RPMSTATEDIR "$cfgdir"/rpmstate "$cfgdir"/base/rpm/state
215 mkdir -m755 -p "$cfgdir"
218 if test "$have_apt"; then
219 findDir APTETCDIR "$cfgdir"/aptetc "$cfgdir"/base/apt/etc /
220 findDir APTSTATEDIR "$cfgdir"/aptstate "$cfgdir"/base/apt/state /
221 findDir APTCACHEDIR "$cfgdir"/aptcache "$cfgdir"/base/apt/cache /
222 findDir APTARCHIVDIR "$cfgdir"/aptarchives "$cfgdir"/base/apt/archives /
224 test "$APTETCDIR" != / || APTETCDIR=$cfgdir/base/apt/etc
225 test "$APTSTATEDIR" != / || APTSTATEDIR=$cfgdir/base/apt/state
226 test "$APTCACHEDIR" != / || APTCACHEDIR=$cfgdir/base/apt/cache
227 test "$APTARCHIVDIR" != / || APTARCHIVDIR=$cfgdir/base/apt/archive
229 test -d "$cfgdir"/aptetc -a -d "$cfgdir"/aptstate -a \
230 -d "$cfgdir"/aptcache -a -d "$cfgdir"/aptarchives || need_base=1
233 findDir RPMETCDIR "$cfgdir"/rpmetc "$cfgdir"/base/rpm/etc /
234 findDir RPMSTATEDIR "$cfgdir"/rpmstate "$cfgdir"/base/rpm/state /
236 test "$RPMETCDIR" != / || RPMETCDIR=$cfgdir/base/rpm/etc
237 test "$RPMSTATEDIR" != / || RPMSTATEDIR=$cfgdir/base/rpm/state
239 test -d "$cfgdir"/rpmetc -a -d "$cfgdir"/rpmstate || need_base=1
240 test ! -e "$cfgdir"/base || need_base=
242 test -z "$need_base" || ln -s "$PKGCFGDIR" "$cfgdir"/base
244 mkdir -m755 -p "$PKGCFGDIR"
245 _createDirs "$APTETCDIR" "$APTSTATEDIR" "$APTCACHEDIR" "$APTARCHIVDIR" \
246 "$RPMETCDIR" "$RPMSTATEDIR"
250 if test "$is_internalize"; then
251 if test "$have_apt"; then
252 _copySecure "$vdir" "$APTETCDIR" /etc/apt
253 pushd "$vdir" >/dev/null
254 _hashAuto /etc/apt/apt.conf '/'
258 _copySecure "$vdir" "$RPMETCDIR" /etc/rpm
259 _copySecure "$vdir" "$RPMSTATEDIR" /var/lib/rpm
262 if test "$have_apt"; then
263 _copySecureRev "$vdir" /etc/apt "$APTETCDIR"
264 _unhashAuto "$APTETCDIR"/apt.conf '/'
267 _copySecureRev "$vdir" /etc/rpm "$RPMETCDIR"
268 _copySecureRev "$vdir" /var/lib/rpm "$RPMSTATEDIR"
272 if test "$is_internalize"; then
275 tmpdir=$(mktemp -d /var/tmp/pgmgmt.XXXXXX)
276 trap "rm -rf $tmpdir" EXIT
277 pushd "$vdir" >/dev/null
278 $_EXEC_CD /var/lib /bin/mv rpm $tmpdir/
279 $_EXEC_CD /var/lib /bin/ln -s "$rpmdb_mntpoint" rpm
284 if test "$is_internalize"; then
285 touch "$cfgdir"/internal
287 rm -f "$cfgdir"/internal
291 function processVserver_Debian()
294 local is_internalize=$2
296 if test "$is_internalize"; then
297 echo $"Debian vservers should be internalized everytime; do not know how to handle '$vserver'" >&2
299 echo $"External packagemanagement is not supported for Debian vserver" >&2
305 function processVserver()
312 ! $_VSERVER_INFO -q "$vserver" RUNNING || {
313 echo $"Can not operate on running vservers; please stop '$vserver' and retry again..."
317 vdir=$($_VSERVER_INFO "$vserver" VDIR) && test -d "$vdir" || {
318 echo $"Vserver '$vserver' does not seem to exist; skipping it..."
322 pkgmgmt.isInternal "$vserver" || is_external=1
324 case "$is_external"X"$IS_INTERNALIZE"X"$IS_EXTERNALIZE" in
325 (*X1X1) echo $"Can not externalize and internalize at the same time";;
326 (*XX) echo $"No operation specified; try '--help' for more information";;
327 (1XX1) echo $"Vserver '$vserver' has already external packagemanagment; skipping it...";;
328 (X1X) echo $"Vserver '$vserver' has already internal packagemanagment; skipping it...";;
332 test -z "$skip" || return 1
335 _mountFilesystems "$vserver" || return 1
336 pkgmgmt.guessStyle "$vserver" style || return 1
339 (redhat|mandrake) processVserver_RH "$vserver" "$IS_INTERNALIZE";;
340 (debian) processVserver_Debian "$vserver" "$IS_INTERNALIZE";;
342 echo $"Vserver style '$style' is not supported for packagemanagment" >&2
346 _umountFilesystems "$vserver" || return 1
349 tmp=$(getopt -o y --long debug,externalize,internalize,help,version -n "$0" -- "$@") || exit 1
358 (--help) showHelp $0;;
359 (--version) showVersion;;
361 (--externalize) IS_EXTERNALIZE=1;;
362 (--internalize) IS_INTERNALIZE=1;;
365 (*) echo $"vserver: internal error; arg=='$1'" >&2; exit 1;;
371 echo $"No vserver specified; try '--help' for more information"
382 processVserver "$i" && passed=1 || ok=
385 test -z "$ok" || exit 0
386 test -z "$passed" || exit 1